//----------------------------------------------------------------------------------------
// UJavelinView.cp
// Copyright 1991-1992 Apple Computer, Inc.
//----------------------------------------------------------------------------------------

#ifndef __UJAVELINVIEW__
#include "UJavelinView.h"
#endif


#ifndef __U3DDRAWING__
#include "U3DDrawing.h"
#endif


#ifndef __UDOCUMENTJAVELIN__
#include "UDocumentJavelin.h"
#endif

#ifndef __UREMOTECOMMANDS__
#include "URemoteCommands.h"
#endif

#ifndef __UCOMMANDJAVELIN__
#include "UCommandJavelin.h"
#endif

#ifndef __UAPPLICATIONJAVELIN__
#include "UApplicationJavelin.h"
#endif

#ifndef __RESOURCES__
#include "Resources.h"
#endif

//----------------------------------------------------------------------------------------
//const ResNumber kJavelinWindowID 	= kDefaultWindowID;

//========================================================================================
// Global Initialization Procedure
//========================================================================================

//----------------------------------------------------------------------------------------
// InitUJavelinView: 
//----------------------------------------------------------------------------------------
#pragma segment DlgInit
pascal void InitUJavelinView()
{
	// So the linker doesn't dead strip class info 
	macroDontDeadStrip(TJavelinView);
	
	Handle theVersion;
	theVersion = Get1Resource('vers',1);
		
	memcpy(gJavelinVersion, *theVersion + 6, 6);   //reads the short string not the numbers (bytes 1 and 2)
	ptocstr(gJavelinVersion);
	
} // InitUJavelinView


//----------------------------------------------------------------------------------------
// TJavelinView::Initialize: 
//----------------------------------------------------------------------------------------
#pragma segment AOpen

pascal void TJavelinView::Initialize() // Override 
{
	inherited::Initialize();
	
	fDocument = NULL;
	
	Handle preview = NULL;
	VOLATILE(preview);				// needed in failure handler

	THandleStream* aHandleStream = NULL;
	VOLATILE(aHandleStream);				// needed in failure handler

	preview = NewPermHandle(0);

	aHandleStream = new THandleStream;
	aHandleStream->IHandleStream(preview, 6);

	fStream = aHandleStream;	


} // TJavelinView::Initialize 
	

//----------------------------------------------------------------------------------------
// TJavelinView::Draw: 
//----------------------------------------------------------------------------------------
#pragma segment ARes

pascal void TJavelinView::Draw(const VRect& area) // Override 
{
	inherited::Draw(area);
/*
	CRect drawQDRect;
	CRGBColor 		color;
	GetForeColor(color);
	this->GetVisibleQDRect(drawQDRect);
	
	RGBForeColor (kLightGray);
	PaintRect(drawQDRect);
	RGBForeColor (color);
*/
} // TJavelinView::Draw 


//----------------------------------------------------------------------------------------
// TJavelinView::DoPostCreate: 
//----------------------------------------------------------------------------------------
#pragma segment AOpen
	
pascal void TJavelinView::DoPostCreate(TDocument* itsDocument) // Override 
{
	inherited::DoPostCreate(itsDocument);
	fDocument = (TDocumentJavelin*) itsDocument;
} // TJavelinView::DoPostCreate 

	
//----------------------------------------------------------------------------------------
// TJavelinView::DoSetupMenus: This method is overridden to enable menu items which
// should be enabled when this view is in the target chain. MacApp initially disables all
// menu items, then lets the objects in the target chain enable those items they handle.
//
// A view is generally in the target chain when its window is the active window, and the
// view or one of its subviews is designated as the target of that window. In this
// example, the window's resource specifies the skeleton view as the target.
// 
// The inherited method is called so that objects further up the target chain (the
// scroller, window, document and application) can set up THEIR menus.
//----------------------------------------------------------------------------------------
#pragma segment ARes
			
pascal void TJavelinView::DoSetupMenus() // Override 
{
	inherited::DoSetupMenus();
} // TJavelinView::DoSetupMenus 

//--------------------------------------------------------------------------------------------------
#pragma segment ARes

pascal TDocumentJavelin* TJavelinView::GetDocument()
{
	// Accessor function
	return fDocument;
}

