/*									MicrosecondTrap.h								*/
/*
 * MicrosecondTrap.h
 * Copyright  1994 Apple Computer Inc.
 */
#ifndef __MicrosecondTrap__
#define __MicrosecondTrap__
#include <Types.h>
#include <Traps.h>
#include <Timer.h>


/*
 * TRUE if the Microsecond Trap is present.
 */
Boolean						MicrosecondTrapPresent(void);

/*
 * Convert a Microsecond value to a double-precision number of microseconds.
 */
double						MicrosecondToDouble(
		register const UnsignedWide	*epochPtr
	);

/*
 * Return the difference between two Microsecond Trap values.
 * Integer subtraction is used to preserve accuracy.
 */
void
MicrosecondDelta(
		register const UnsignedWide	*startPtr,
		register const UnsignedWide	*endPtr,
		register UnsignedWide		*result
	);
#endif /* __MicrosecondTrap__ */


