#include <QuickTimeComponents.h>
#include <Windows.h>

typedef struct {
	WindowPtr					window;
	SeqGrabComponent 			sg;
	MTConferenceComponent		confComponent;
	MTControllerComponent		controller;
	MTDirectorComponent			director;
	Boolean						casting;
	MTConferenceToken			conference;
} CastRecord;

ComponentResult	OpenCast( WindowPtr window, SeqGrabComponent sg, CastRecord** cr);
ComponentResult CloseCast( CastRecord* cr );

Boolean 		IsCastEvent( CastRecord* cr, EventRecord* theEvent );
ComponentResult CheckCast( CastRecord* cr );

ComponentResult StartCasting( CastRecord* cr, Str63 name );
ComponentResult StopCasting(  CastRecord* cr );

ComponentResult CopyCast( CastRecord* cr, PicHandle* pic );

Boolean 		IsCasting( CastRecord* cr );

ComponentResult CastChannelSettings( CastRecord* cr,  SGChannel channel );

ComponentResult SetupSequenceGrabber( SeqGrabComponent* sg, 
									  SGChannel* soundChannel, 
									  SGChannel* videoChannel,  
									  UserData settings );

ComponentResult CastChangedWindowBefore( CastRecord* cr, Boolean finished );