/*
	File:		ListEx1Part.r

	Contains:	ListEx1Part Resources

	Written by:	Steve Smith

	Copyright:	 1994-95 by Apple Computer, Inc., all rights reserved.
*/

#define SystemSevenOrBetter 1			// we want the extended types
#define	SystemSevenOrLater	1			// Types.r uses this variable

// -- MPW Rez Includes --

#include "Types.r"
#include "SysTypes.r"
#include "CodeFragmentTypes.r"

// -- OpenDoc Includes --

#ifndef __ODTYPES_R__
#include "ODTypes.r"
#endif

#ifndef SOM_Module_OpenDoc_StdDefs_defined
#include "StdDefs.r"
#endif

// -- ListEx1Part Includes --

#ifndef _LISTEX1PARTDEF_
#include "ListEx1PartDef.h"
#endif

#ifndef _LISTEX1PARTVERS_
#include "ListEx1PartVers.h"
#endif

//-------------------------------------------------------------------------------------
// .rsrc resources
//-------------------------------------------------------------------------------------

// ListEx1Part - This gets the resources from my .rsrc file (PICTs etc.)
include "ListEx1PartOtherResources.rsrc";

//-------------------------------------------------------------------------------------
// Finder Version Resources
//-------------------------------------------------------------------------------------

// Part's Finder Version Resource

resource 'vers' (1) {
	currentMajorVersion,
	finderMinorVersion,
	developmentStage,
	preReleaseNumber,
	verUS,
	shortVersionStr,
	shortVersionStr",  Apple Computer, Inc. 1994-1995"
};

resource 'vers' (2) {
	currentMajorVersion,
	finderMinorVersion,
	developmentStage,
	preReleaseNumber,
	verUS,
	shortVersionStr,
	"OpenDoc Sample Code"
};

//-------------------------------------------------------------------------------------
// Code Fragment Resources
//-------------------------------------------------------------------------------------

resource 'cfrg' (0) {
	{	/* [1] */
#ifdef _68KBUILD_
		kMotorola,
#else
		kPowerPC,
#endif
		kFullLib,
		currentVersion,
		compatibleVersion,
		kDefaultStackSize,
		kNoAppSubFolder,
		kIsLib,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		kListEx1PartID,		/* This must be the class ID. */
		/* [2] */
#ifdef _68KBUILD_
		kMotorola,
#else
		kPowerPC,
#endif
		kFullLib,
		currentVersion,
		compatibleVersion,
		kDefaultStackSize,
		kNoAppSubFolder,
		kIsLib,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		kPartClassName		/* This must be the SOM class name */
							/* for this part.				   */
	}
};

//-------------------------------------------------------------------------------------
// NMAP Resources
//-------------------------------------------------------------------------------------

// Map a part's class id (module::classname)
// to a part's kind (unique content identifier)
//
resource kODNameMappings (kEditorKindMapId) {
	kODEditorKinds,
	{	/* array Types: 1 elements */
		/* [1] */
		kListEx1PartID,
		kODIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kListEx1PartKind
			}
		}
	}
};

// Map a part's class id (module::classname)
// to a human readable string.
//
resource kODNameMappings (kEditorUserStringMapId) {
	kODEditorUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kListEx1PartID,
		kODIsINTLText
		{
			smRoman,
			langEnglish,
			kListEx1PartEditorUserString
		}
	}
};

// Map a part's kind (unique content identifier)
// to a generic content category identifier.
//
resource kODNameMappings (kKindCategoryMapId) {
	kODKind,
	{	/* array Types: 1 elements */
		/* [1] */
		kListEx1PartKind,
		kODIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kListEx1PartCategory
			}
		}
	}
};

// Map a part's kind (unique content identifier)
// to a human readable string.
//
resource kODNameMappings (kKindUserStringMapId) {
	kODKindUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kListEx1PartKind,
		kODIsINTLText
		{
			smRoman,
			langEnglish,
			kListEx1PartKindUserString
		}
	}
};

// Map a part's generic content category identifier
// to a human readable string.
//
resource kODNameMappings (kCategoryUserStringMapId) {
	kODCategoryUserString,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kListEx1PartCategory,
		kODIsINTLText {
			smRoman,
			langEnglish,
			kListEx1PartCategoryUserString
		}
	}
};

// Map a part's kind (unique content identifier)
// to an old style MacOS Type (and/or ScrapType).
//
resource kODNameMappings (kOldMacOSTypeMapId) {
	kODKindOldMacOSType,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kListEx1PartKind,
		kODIsMacOSType {
			kListEx1PartDocumentOSType
		}
	}
};

//-------------------------------------------------------------------------------------
// OLE Interoperability Support
//-------------------------------------------------------------------------------------

// This resource allows your editor to be registered with the OLE runtime on the
// Macintosh and subsequently interoperate with OLE clients/servers. Contact Microsoft
// to acqiure a unique class ID.
resource 'olcr' (0, "OLE Class ID")
{
   "{80C11F40-7503-8576-00D01113F11}"; /* your part's CLSID */
};

//-------------------------------------------------------------------------------------
// String List Resources
//-------------------------------------------------------------------------------------

resource 'STR#' (kMenuStringResID, "Menu Items strings") {
	{	/* array StringArray: 3 elements */
		/* [1] */
		"About ListEx1Part",
		/* [2] */
		"PART",
		/* [3] */
		"Sample  Sample"
	}
};

resource 'STR#' (kErrorStringResID, "Error strings") {
	{	/* array StringArray: 6 elements */
		/* [1] */
		"ListEx1Part was unable completely initi"
		"alize its internal structures.",
		/* [2] */
		"ListEx1Part was unable to open the docu"
		"ment due to unforseen circumstances.",
		/* [3] */
		"ListEx1Part was unable to open a part w"
		"indow due to unforseen circumstances.",
		/* [4] */
		"ListEx1Part has been asked to remove a "
		"frame that does not belong to it, or an "
		"error occurred while removing the frame "
		"from internal storage.",
		/* [5] */
		"A window that ListEx1Part created has b"
		"een deleted without its knowledge. This "
		"may generate a fatal error in the near f"
		"uture. Please close the document immedia"
		"tely to prevent data loss.",
		/* [6] */
		"ListEx1Part encountered a fatal error w"
		"hile trying to save. Try saving again or"
		" closing the document."
	}
};

//-------------------------------------------------------------------------------------
// Finder Related Resources
//-------------------------------------------------------------------------------------

// Kind resources affect the text Finder displays in the
// "kind" column and file info dialog. This feature was
// introduced as part of Macintosh Easy Open.
//
resource 'kind' (kBaseResourceID) {
	kListEx1PartEditorOSType,
	0, /* region = USA */
	{
		'shlb', "OpenDoc editor"
	}
};
	
resource 'kind' (kBaseResourceID+1) {
	kListEx1PartViewerOSType,
	0, /* region = USA */
	{
		'shlb', "OpenDoc viewer"
	}
};
	
resource 'kind' (kBaseResourceID+2) {
	kODShellSignature,
	0, /* region = USA */
	{
		kListEx1PartDocumentOSType, "ListEx1Part 1.0 document",
		kListEx1PartStationeryOSType, "ListEx1Part 1.0 stationery"
	}
};

// The -16397 string will be displayed by Finder when a user
// tries to open the editor shared library. The string should
// give the user a little detail about the part's capabilities
// and enough information to install the part in the correct location.
//
resource 'STR ' (-16397, purgeable) {
	"OpenDoc editor\n\nListEx1Part demonstrates the functionality of a very "
	"basic part. To work properly, it should be placed in the Editors folder. "
	"To create a new document, open a stationery pad."
};

//-------------------------------------------------------------------------------------
// Dialog Resources
//-------------------------------------------------------------------------------------

resource 'DLOG' (kAboutBoxID, "ListEx1Part About Box") {
	{0, 0, 250, 350},
	dBoxProc,
	invisible,
	goAway,
	0x0,
	kAboutBoxID,
	"",
	alertPositionMainScreen
};

resource 'DITL' (kAboutBoxID) {
	{	/* array DITLarray: 8 elements */
		/* [1] */
		{222, 270, 242, 338}, Button { enabled, "OK" },
		/* [2] */
		{24, 25, 56, 57}, Picture { disabled, kEditorIconPicture },
		/* [3] */
		{13, 68, 237, 69}, Button { disabled, "" },
		/* [4] */
		{64, 13, 65, 337}, Button { disabled, "" },
		/* [5] */
		{46, 76, 62, 172}, StaticText { disabled, "ListEx1Part" },
		/* [6] */
		{76, 76, 116, 304}, StaticText { disabled,
			"ListEx1Part is a sample part editor which"
			" illustrates the functionality of a basi"
			"c part editor." },
		/* [7] */
		{124, 76, 152, 304}, StaticText { disabled,
			"Written by Steve Smith with support from"
			" the OpenDoc Engineering team." },
		/* [8] */
		{172, 76, 200, 300}, StaticText { disabled,
			"Copyright 1994,1995 by Apple Computer, "
			"Inc. All Rights Reserved." }
	}
};

resource 'dctb' (kAboutBoxID) {
	/* dialog background fill color */
	{	/* array ColorSpec: 5 elements */
		/* [1] */
		wContentColor, 59127, 59127, 59127,
		/* [2] */
		wFrameColor, 0, 0, 0,
		/* [3] */
		wTextColor, 0, 0, 0,
		/* [4] */
		wHiliteColor, 0, 0, 0,
		/* [5] */
		wTitleBarColor, 65535, 65535, 65535
	}
};

data 'ictb' (kAboutBoxID) {
	/* dialog control text styling */
	$"0000 0000 0000 0000 0028 0020 0028 0048"
	$"8007 0070 8007 0084 8007 0098 8007 00AC"
	$"0000 0000 0000 0003 0000 7FFF 7FFF 7FFF"
	$"0001 FFFF FFFF FFFF 0002 0000 0000 0000"
	$"0003 FFFF FFFF FFFF 0000 0000 0000 0003"
	$"0000 7FFF 7FFF 7FFF 0001 FFFF FFFF FFFF"
	$"0002 0000 0000 0000 0003 FFFF FFFF FFFF"
	$"00C0 0100 000E 0000 0000 0000 FFFF FFFF"
	$"FFFF 0000 00C9 0000 0009 0000 0000 0000"
	$"FFFF FFFF FFFF 0000 00D0 0000 0009 0000"
	$"0000 0000 FFFF FFFF FFFF 0000 00D7 0000"
	$"0009 0000 0000 0000 FFFF FFFF FFFF 0000"
	$"0850 616C 6174 696E 6F06 4765 6E65 7661"
	$"0647 656E 6576 6106 4765 6E65 7661"
};

resource 'DLOG' (kErrorBoxID, "ListEx1Part Error Box") {
	{57, 46, 244, 374},
	dBoxProc,
	invisible,
	goAway,
	0x0,
	kErrorBoxID,
	"",
	alertPositionParentWindowScreen
};

resource 'DITL' (kErrorBoxID) {
	{	/* array DITLarray: 5 elements */
		/* [1] */
		{153, 256, 173, 314}, Button { enabled, "OK" },
		/* [2] */
		{153, 185, 173, 243}, Button { enabled, "Cancel" },
		/* [3] */
		{11, 70, 124, 317}, StaticText { disabled,
			"<< Use this for errors in the Editor, su"
			"ch as out of memory, unable to acquire s"
			"ome system resource, etc.>> \nUser errors"
			" use a standard alert appearance. See DI"
			"TL 129.>>" },
		/* [4] */
		{11, 19, 43, 51}, Picture { disabled, kEditorIconPicture },
		/* [5] */
		{149, 252, 177, 318}, UserItem { disabled }
	}
};

//-------------------------------------------------------------------------------------
// Finder Bundle Information
//-------------------------------------------------------------------------------------

resource 'BNDL' (kDocumentBundle, "Document BNDL") {
	kODShellSignature,
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'FREF',
		{	/* array IDArray: 2 elements */
			/* [1] */
			0, kDocumentFREF,
			/* [2] */
			1, kStationeryFREF
		},
		/* [2] */
		'ICN#',
		{	/* array IDArray: 2 elements */
			/* [1] */
			0, kDocumentIcons,
			/* [2] */
			1, kStationeryIcons
		}
	}
};

resource 'BNDL' (kEditorBundle, "Editor BNDL") {
	kListEx1PartEditorOSType,
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'FREF',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, kEditorFREF
		},
		/* [2] */
		'ICN#',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, kEditorIcons
		}
	}
};

resource 'BNDL' (kViewerBundle, "Viewer BNDL") {
	kListEx1PartViewerOSType,
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'FREF',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, kViewerFREF
		},
		/* [2] */
		'ICN#',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, kViewerIcons
		}
	}
};

resource 'FREF' (kDocumentFREF) {
	kListEx1PartDocumentOSType, 0, ""
};

resource 'FREF' (kStationeryFREF) {
	kListEx1PartStationeryOSType, 1, ""
};

resource 'FREF' (kEditorFREF) {
	'shlb', 0, ""
};

resource 'FREF' (kViewerFREF) {
	'shlb', 0, ""
};

data kODShellSignature (0, "Owner resource") {
	$"00"
};

data kListEx1PartViewerOSType (0, "Owner resource") {
	$"00"
};

data kListEx1PartEditorOSType (0, "Owner resource") {
	$"00"
};
