/*
	File:		ListEx2PartDef.h

	Contains:	Common definitions used by ListEx2Part.cpp & .r files.

	Written by:	Steve Smith

	Copyright:	 1994-95 by Apple Computer, Inc., all rights reserved.
	
	-------------------------------------------------------------------
	
	Note:		This file will need to be modified for any derivitive
				work based on ListEx2Part. The areas marked with (CH)
				should be considered when making those changes.
*/


#ifndef _LISTEX2PARTDEF_
#define _LISTEX2PARTDEF_

// -- OpenDoc Includes --

#ifndef SOM_Module_OpenDoc_StdDefs_defined
#include <StdDefs.xh>
#endif

//=====================================================================

// Class / Editor ID (CH)
#define kPartClassName					"som_ListEx2Part"
#define kListEx2PartID					"ACF_DevServ3::"kPartClassName

// Editor User String (CH)
#define kListEx2PartEditorUserString 	"ListEx2Part 1.0"

// Kind (CH)
#define kListEx2PartKind				kODISOPrefix "Apple:Kind:ListEx2Part"

// Kind User String (CH)
#define kListEx2PartKindUserString		"ListEx2Part"

// Category (CH)
#define kListEx2PartCategory			kODISOPrefix "Apple:Category:List Data"

// Category User String (CH)
#define kListEx2PartCategoryUserString 	"List Data"

// ListEx2Part OSTypes (CH)
#define kListEx2PartEditorOSType		'L'
#define kListEx2PartViewerOSType		'L'
#define kListEx2PartDocumentOSType		'DL'
#define kListEx2PartStationeryOSType	'sL'

// ISO Strings (CH)
#define kMainPresentation  				kODISOPrefix "ListEx2Part:Presentation:Main"
#define kListEx2PartInfo				kODISOPrefix "ListEx2Part:Display Frame Info"

// ListEx2Part defines
#define	kBaseResourceID					20001

// NMAP Resource IDs
#define kKindCategoryMapId				kBaseResourceID+1
#define kEditorKindMapId				kBaseResourceID+2
#define kEditorUserStringMapId			kBaseResourceID+3
#define kKindUserStringMapId			kBaseResourceID+4
#define kCategoryUserStringMapId		kBaseResourceID+5
#define kOldMacOSTypeMapId				kBaseResourceID+6

// Text Items
#define	kMenuStringResID				kBaseResourceID
#define	kAboutTextID        			1
#define	kDefaultContent1ID				2
#define	kDefaultContent2ID				3

// Error Messages
#define kErrorStringResID				kMenuStringResID+1
#define kErrStrFieldID					3
#define kErrCantInitializePart			1
#define kErrCantOpenDocWindow			2
#define kErrCantOpenPartWindow			3
#define kErrRemoveFrame					4
#define kErrWindowGone					5
#define kErrExternalizeFailed			6

// Bundles/FREFs
#define kDocumentBundle					kBaseResourceID
#define kEditorBundle					kBaseResourceID+1
#define kViewerBundle					kBaseResourceID+2
#define kDocumentFREF					kBaseResourceID
#define kStationeryFREF					kBaseResourceID+1
#define kEditorFREF						kBaseResourceID+2
#define kViewerFREF						kBaseResourceID+3

// Icons
#define	kLargeIcons						1
#define	kSmallIcons						2
#define	kDocumentIcons					kBaseResourceID
#define	kStationeryIcons				kBaseResourceID+1
#define	kEditorIcons					kBaseResourceID+2
#define	kViewerIcons					kBaseResourceID+3

// Pictures
#define kEditorIconPicture				kBaseResourceID
#define	kThumbnailPicture				kBaseResourceID+1

// Dialogs & Windows
#define	kAboutBoxID  					kBaseResourceID
#define	kErrorBoxID  					kBaseResourceID+1
#define	kMacWindowTitleBarHeight		20
#define	kALittleNudge					4
#define kMinVertVisPortion				10
#define kMinHorzVisPortion				16

// Display Frames
#define kFrameRemoved					1
#define kFrameClosed					0

// Geometry
#define kMinImagingResolution			72 // dpi

#endif

