#
#	File:		ListPart.make
#
#	Contains:	Makefile for OpenDoc ListPart viewer
#
#	Written by:	Steve Smith
#
#	Copyright:	 1994-1995 by Apple Computer, Inc., all rights reserved.
#

#---------------------------------------------------------------------------	
# PROJECT VARIABLES
#---------------------------------------------------------------------------	

TargetName = ListPart
TargetNameILink = {TargetName} (68k)
TargetNamePPCLink = {TargetName} (PPC)
TargetNameFat = {TargetName} (fat)

TargetCreatorType = "L"

AdditionalIncludes = -i "{somSourceDir}" -i "{SourceDir}"
AdditionalIDLIncludes = -i "{SourceDir}"

#---------------------------------------------------------------------------	
# CFM/PEF Version Numbers
#---------------------------------------------------------------------------	
# For detailed instructions on proper CFM/PEF version numbering, see
# Code Fragment Chapter (pg 3-7), Inside Macintosh: PowerPC System Software
#---------------------------------------------------------------------------	

CurrentLibraryVersion =		0x01008000		# 1.0 Final
LibraryExportsVersion =		0x00000000		# 0.0
LibraryCodeVersion =		0x00000000		# 0.0

#---------------------------------------------------------------------------	
# DIRECTORY DEPENDENCIES
#---------------------------------------------------------------------------	

"{TargetDir}"   "{SourceDir}"
"{ObjectsDir}"  "{SourceDir}"
"{ObjectsDir}"  "{somSourceDir}"
"{ObjectsDir}"  "{ODUtilsImplDir}"

#---------------------------------------------------------------------------	
# ROOT TARGET
#---------------------------------------------------------------------------	

BUILDPPCLINK  
	"{CppPrecompiledHeaders}"				
	"{TargetDir}{TargetNamePPCLink}"		
	"{somSourceDir}som_ListPart.exp"

BUILDREZ  
	"{ObjectsDir}{TargetName}.PPC.rsrc"		
	"{ObjectsDir}{TargetName}.68k.rsrc"

BUILDILINK  
	"{CppPrecompiledHeaders}"				
	"{TargetDir}{TargetNameILink}"			
	"{somSourceDir}som_ListPart.exp"

BUILDIDL  
	"{somSourceDir}som_ListPart.xih"		
	"{somSourceDir}som_ListPart.xh"		
	"{somSourceDir}som_ListPart.cpp"		
	"{somSourceDir}som_ListPart.exp"
	

#---------------------------------------------------------------------------	
# FILE LIST VARIABLES
#---------------------------------------------------------------------------	

ListPartOBJECTS = 
	"{ObjectsDir}DebugTools.cpp.o"	
	"{ObjectsDir}ListPartGlobals.cpp.o"	
	"{ObjectsDir}ListPart.cpp.o"			
	"{ObjectsDir}ListPartUtils.cpp.o"		
	"{ObjectsDir}ListPartList.cpp.o"		
	"{ObjectsDir}SampleCollections.cpp.o"	

somListPartOBJECTS = 
	"{ObjectsDir}som_ListPartInit.cpp.o"	
	"{ObjectsDir}som_ListPart.cpp.o"		

OpenDocUtilityOBJECTS = 
	"{ObjectsDir}AltPoint.cpp.o" 			
	"{ObjectsDir}AltPoly.cpp.o" 			
	"{ObjectsDir}BndNSUtl.cpp.o" 			
	"{ObjectsDir}Crawl.cpp.o"	 			
	"{ObjectsDir}DocUtils.cpp.o"	 		
	"{ObjectsDir}Except.cpp.o" 				
	"{ObjectsDir}FocusLib.cpp.o" 			
	"{ObjectsDir}IText.cpp.o" 				
	"{ObjectsDir}FlipEnd.cpp.o" 			
	"{ObjectsDir}ISOStr.cpp.o" 				
	"{ObjectsDir}LinkList.cpp.o" 			
	"{ObjectsDir}NmSpcUtl.cpp.o" 			
	"{ObjectsDir}ODDebug.cpp.o" 			
	"{ObjectsDir}ODMemory.cpp.o"			
	"{ObjectsDir}ODNew.cpp.o"				
	"{ObjectsDir}ODUtils.cpp.o"				
	"{ObjectsDir}PasclStr.cpp.o"			
	"{ObjectsDir}PlfmFile.cpp.o" 			
	"{ObjectsDir}StorUtil.cpp.o"			
	"{ObjectsDir}StdTypIO.cpp.o"			
	"{ObjectsDir}TempIter.cpp.o"			
	"{ObjectsDir}TempObj.cpp.o"				
	"{ObjectsDir}UseRsrcM.cpp.o" 			
	"{ObjectsDir}WinUtils.cpp.o" 			
			
			
#---------------------------------------------------------------------------	
# DEPENDENCIES
#---------------------------------------------------------------------------	

# --- IDL ---

"{somSourceDir}"som_ListPart.cpp 	
	"{somSourceDir}"som_ListPart.idl	
	"{ODIDLIntfDir}"Part.idl
	
"{somSourceDir}"som_ListPart.xih 	
	"{somSourceDir}"som_ListPart.xh	
	"{somSourceDir}"som_ListPart.idl	
	"{SourceDir}ListPartVers.h"		
	"{ODIDLIntfDir}"Part.idl
	
"{somSourceDir}"som_ListPart.xh 		
	"{somSourceDir}"som_ListPart.idl	
	"{SourceDir}ListPartVers.h"		
	"{ODIDLIntfDir}"Part.idl

# --- SOURCE ---

"{ObjectsDir}ListPart.cpp.o"				
	"{CppPrecompiledHeaders}"				
	"{SourceDir}ListPart.cpp" 			
	"{SourceDir}ListPart.h" 				
	"{SourceDir}ListPartDef.h" 			
	"{SourceDir}ListPartUtils.h"
	
"{ObjectsDir}ListPartUtils.cpp.o"			
	"{CppPrecompiledHeaders}"				
	"{SourceDir}ListPartUtils.cpp"		
	"{SourceDir}ListPartUtils.h"
	
"{ObjectsDir}ListPartList.cpp.o"			
	"{CppPrecompiledHeaders}"				
	"{SourceDir}ListPartList.cpp"

"{ObjectsDir}SampleCollections.cpp.o"		
	"{CppPrecompiledHeaders}"				
	"{SourceDir}SampleCollections.cpp"		
	"{SourceDir}SampleCollections.h"

# --- SOM OBJECTS ---

"{ObjectsDir}som_ListPart.cpp.o"			
	"{CppPrecompiledHeaders}"				
	"{somSourceDir}som_ListPart.cpp"		
	"{somSourceDir}som_ListPart.xih"		
	"{SourceDir}ListPart.h"

"{ObjectsDir}som_ListPartInit.cpp.o"		
	"{CppPrecompiledHeaders}"				
	"{somSourceDir}som_ListPartInit.cpp"	
	"{somSourceDir}som_ListPart.xh"


#---------------------------------------------------------------------------	
# BUILD LIBRARIES
#---------------------------------------------------------------------------	

# --- 68k Link ---

"{TargetDir}{TargetNameILink}"  	 {ListPartOBJECTS}			
									 {somListPartOBJECTS}			
									 {OpenDocUtilityOBJECTS}		
									 "{somSourceDir}som_ListPart.exp"
	Echo Linking: {TargetNameILink}
	{LinkTool}	
		-export `ConvertExportList "{somSourceDir}som_ListPart.exp"` 
		{ILinkOptions}										
		{ILinkShLibOptions}									
		-init ListPartCFMInit								
		-vercur {CurrentLibraryVersion}						
		-verdef {LibraryExportsVersion}						
		-verimp {LibraryCodeVersion}						
		{ShLibPreLibraries}									
		{ListPartOBJECTS}									
		{somListPartOBJECTS}								
		{OpenDocUtilityOBJECTS}								
		"{ODCFMLibrariesDir}OpenDoc Core.stub"				
		"{ODCFMLibrariesDir}OpenDoc User Interface.stub"	
		"{ODCFMLibrariesDir}OpenDoc Storage.stub"			
		"{ODCFMLibrariesDir}OpenDoc Imaging.stub"			
		"{ODCFMLibrariesDir}OpenDoc Layout.stub"			
		"{ODCFMLibrariesDir}Memory Manager.stub"			
		{ShLibPostLibraries}								
		-o "{ObjectsDir}{TargetNameILink}".seg
	If !{Status}
		Echo Building: {TargetNameILink}.SYM
		{SymTool} "{ObjectsDir}{TargetNameILink}".seg.NJ	
				-o "{TargetDir}{TargetNameILink}".SYM -sym 3.2
		Echo Building: {TargetNameILink}'s code/data fragment
		MakeFlat "{ObjectsDir}{TargetNameILink}".seg -o "{TargetDir}{TargetNameILink}"
		Echo Copying: {TargetNameILink}'s resources
		Echo "include "{RsrcObjectsDir}{TargetName}.68k.rsrc";" | Rez -a -o "{TargetDir}{TargetNameILink}"
		Echo "delete 'ckid';"  | Rez -a -o "{TargetDir}{TargetNameILink}"
		SetFile -a Bi -c "{TargetCreatorType}" {Targ}
	End

# --- PowerPC Link ---

"{TargetDir}{TargetNamePPCLink}" 		{ListPartOBJECTS}			
										{somListPartOBJECTS}		
										{OpenDocUtilityOBJECTS}		
										"{somSourceDir}som_ListPart.exp"
	Echo Linking: {TargetNamePPCLink}
	{LinkTool}	
		-export `ConvertExportList "{somSourceDir}som_ListPart.exp"` 
		{PPCLinkOptions}									
		{PPCLinkShLibOptions}								
		-init ListPartCFMInit								
		-verCur {CurrentLibraryVersion}						
		-verDef {LibraryExportsVersion}						
		-verImp {LibraryCodeVersion}						
		{PPCShLibPreLibraries}								
		{ListPartOBJECTS}									
		{somListPartOBJECTS}								
		{OpenDocUtilityOBJECTS}								
		"{ODCFMLibrariesDir}OpenDoc Core.stub"				
		"{ODCFMLibrariesDir}OpenDoc User Interface.stub"	
		"{ODCFMLibrariesDir}OpenDoc Storage.stub"			
		"{ODCFMLibrariesDir}OpenDoc Imaging.stub"			
		"{ODCFMLibrariesDir}OpenDoc Layout.stub"			
		"{ODCFMLibrariesDir}Memory Manager.stub"			
		{PPCShLibPostLibraries}								
		-o "{ObjectsDir}{TargetNamePPCLink}"
	If !{Status}
		Move "{ObjectsDir}{TargetNamePPCLink}" "{TargetDir}"
		Echo Building: {TargetNamePPCLink}.xSYM
		{SymTool} "{ObjectsDir}{TargetNamePPCLink}".xcoff			
				{AdditionalIncludes} -i "{ODUtilsImplDir}"			
				-sym on,3.2 -o "{TargetDir}{TargetNamePPCLink}".xSYM
		Echo Copying: {TargetNamePPCLink}'s resources
		Echo "include "{RsrcObjectsDir}{TargetName}.PPC.rsrc";" | Rez -a -o "{TargetDir}{TargetNamePPCLink}"
		Echo "delete 'ckid';"  | Rez -a -o "{TargetDir}{TargetNamePPCLink}"
		SetFile -a Bi -c "{TargetCreatorType}" {Targ}
	End


#---------------------------------------------------------------------------	
# REZ STEPS
#---------------------------------------------------------------------------	

"{RsrcObjectsDir}{TargetName}.PPC.rsrc"									
										"{SourceDir}ListPart.r"		
										"{SourceDir}ListPartDef.h"	
										"{SourceDir}ListPartVers.h"	
										"{SourceDir}ListPartOtherResources.rsrc"
	Echo Rezzing: {TargetName}.r (for PPC)
	Rez {RezOptions} {ODRezIntf} "{SourceDir}{TargetName}.r" -o {targ}
	Echo "delete 'ckid';"  | Rez -a -o {Targ}
	SetFile -a i -c "{ResEditCreator}" -t "{ResEditFileType}" {Targ}
	if ( `exists "{TargetDir}{TargetNamePPCLink}" != ""` )
		Echo Copying: {TargetNamePPCLink}'s resources
		Echo "include ""{Targ}"";" | Rez -a -o "{TargetDir}{TargetNamePPCLink}"
	end	

"{RsrcObjectsDir}{TargetName}.68k.rsrc"									
										"{SourceDir}ListPart.r"		
										"{SourceDir}ListPartDef.h"	
										"{SourceDir}ListPartVers.h"	
										"{SourceDir}ListPartOtherResources.rsrc"
	Echo Rezzing: {TargetName}.r (for 68k)
	Rez -d _68KBUILD_ {RezOptions} {ODRezIntf} "{SourceDir}{TargetName}.r" -o {Targ} 
	Echo "delete 'ckid';"  | Rez -a -o {Targ}
	SetFile -a i -c "{ResEditCreator}" -t "{ResEditFileType}" {Targ}
	if ( `exists "{TargetDir}{TargetNameILink}" != ""` )
		Echo Copying: {TargetNameILink}'s resources
		Echo "include ""{Targ}"";" | Rez -a -o "{TargetDir}{TargetNameILink}"
	end


