# Copyright  1996 by Apple Computer, Inc.  All rights reserved.
# TestWide.Make
#
#FILE
#	TestWide.Make
#
#NAME
#	Int64Lib
#
#DESCRIPTION
#
#	This file includes the Make instructions to build
#	the test application for the Wide shared code library
#
#	Supports both MPW 3.3.x (MPW C and PPCC) and MPW 3.4.x (SC and MrC)
#
#MODIFICATION HISTORY
#	Created by Terry Teague
#
#	18 Jul 96	-	TRT	-	Initial version (created initially by CreateMake tool)
#	28 Jul 96	-	TRT	-	Modified to use new naming conventions
#
#################################################################################################

MAKEFILE		=	TestWide.make
MondoBuild	=	{MAKEFILE}  # Make blank to avoid rebuilds when makefile is modified

Includes		=	{Shared.Includes}
Sources			=	:Sources:

SymPPC			=
ObjDirPPC		=	:Objects:
Sym68K			=
ObjDir68K		=	:Objects:

PPCCOptions		=	-i "{Includes}" {SymPPC} 

COptions		=	-i "{Includes}" {Sym68K} 

ObjectsPPC		=	
					"{ObjDirPPC}TestWide.c.x"

Objects68K		=	
					"{ObjDir68K}TestWide.c.o"


# targets to be overriden by SCMBuild script
Wide68K			=	Wide.68K.lib
WidePPC			=	Wide.PPC.xcoff

TestWide68K		=	TestWide.68K
TestWidePPC		=	TestWide.PPC
TestWideFAT		=	TestWide.FAT

# pseudo targets
TestWide			{MondoBuild} {TestWide68K} {TestWidePPC}
	If {TestWide68K} and {TestWidePPC}
		# Duplicate the PowerPC code into the fat binary package.
		Duplicate -y {TestWidePPC} {TestWideFAT}
		# rez in 'CODE' resources from 68K version.  (Brute force method).
		Echo "include "{TestWide68K}" 'CODE';" | Rez -a -o {TestWideFAT}
	End
	
TestWide.PPC.MrC		{MondoBuild} TestWide.PPC

TestWide.68K.SC			{MondoBuild} TestWide.68K

# real targets
TestWide.PPC		{MondoBuild} {ObjectsPPC}
	PPCLink 
		-o {TestWidePPC} {SymPPC} 
		{ObjectsPPC} 
#		-t 'APPL' 
#		-c 'SIOW' 
		{WidePPC} 
		"{PPCLibraries}PPCSIOW.o" 
		"{SharedLibraries}InterfaceLib" 
		"{SharedLibraries}StdCLib" 
		"{SharedLibraries}MathLib" 
		"{PPCLibraries}StdCRuntime.o" 
		"{PPCLibraries}PPCCRuntime.o" 
		"{PPCLibraries}PPCToolLibs.o"
	Rez -d APPNAME="TestWide" -a "{RIncludes}"SIOW.r -o {TestWidePPC}


TestWide.68K		{MondoBuild} {Objects68K}
	If "{MPWVersion}" !~ /3.4/
		# MPW 3.3.x Libraries are organized differently from those of MPW 3.4.x
		Link 
			-o {TestWide68K} {Sym68K} 
			{Objects68K} 
#			-t 'APPL' 
#			-c 'SIOW' 
			{Wide68K} 
			"{CLibraries}Math.o" 
			"{CLibraries}CSANELib.o" 
			"{CLibraries}StdCLib.o" 
			"{Libraries}SIOW.o" 
			"{Libraries}Runtime.o" 
			"{Libraries}Interface.o"
	Else
		Link 
			-o {TestWide68K} {Sym68K} 
			{Objects68K} 
#			-t 'APPL' 
#			-c 'SIOW' 
			{Wide68K} 
			"{Libraries}MathLib.o" 
			"{CLibraries}StdCLib.o" 
			"{Libraries}SIOW.o" 
			"{Libraries}MacRuntime.o" 
			"{Libraries}IntEnv.o" 
			"{Libraries}Interface.o"
	End
	Rez -a "{RIncludes}"SIOW.r -o {TestWide68K}


"{ObjDirPPC}TestWide.c.x"		{MondoBuild} {Sources}TestWide.c 
								{Includes}Wide.h
	If "{MPWVersion}" !~ /3.4/
		# old PPCC compiler requires Apple Extensions option to be on
		{PPCC} {Sources}TestWide.c -o {Targ} {PPCCOptions} -appleext on
	Else
		{PPCC} {Sources}TestWide.c -o {Targ} {PPCCOptions}
	End


"{ObjDir68K}TestWide.c.o"		{MondoBuild} {Sources}TestWide.c 
								{Includes}Wide.h
	{C} {Sources}TestWide.c -o {Targ} {COptions}

