# Copyright  1996 by Apple Computer, Inc.  All rights reserved.
# WideLib.Make
#
#FILE
#	WideLib.Make
#
#NAME
#	Int64Lib
#
#DESCRIPTION
#
#	This file includes the Make instructions to build
#	the Wide shared code library
#
#	Supports both MPW 3.3.x (MPW C and PPCC) and MPW 3.4.x (SC and MrC)
#	For MPW 3.3.x, must use pre-Universal CIncludes
#	(Universal Headers 2.0 has a conflict between Types.h and SANE.h)
#
#MODIFICATION HISTORY
#	Created by Terry Teague
#
#	18 Jul 96	-	TRT	-	Initial version (created initially by CreateMake tool)
#	28 Jul 96	-	TRT	-	Modified to use new naming conventions
#
#################################################################################################

MAKEFILE		=	WideLib.make
MondoBuild	=	{MAKEFILE}	# Make blank to avoid rebuilds when makefile is modified

Includes		=	{Shared.Includes}
Sources			=	:Sources:

SymPPC			= 
ObjDirPPC		=	:Objects:
Sym68K			=
ObjDir68K		=	:Objects:

PPCCOptions		=	-i "{Includes}" {SymPPC} -d PPCC=1 

COptions		=	-i "{Includes}" {Sym68K} -d MPWC=1 

ObjectsPPC		=	
					"{ObjDirPPC}Wide.c.x"

Objects68K		=	
					"{ObjDir68K}Wide.a.o" 
					"{ObjDir68K}Wide.c.o"


# targets to be overriden by SCMBuild script
Wide68K			=	Wide.lib
WidePPC			=	Wide.xcoff

# pseudo targets
WideLib					{MondoBuild} {Wide68K} {WidePPC}

Wide.PPC.xcoff			{MondoBuild} Wide.xcoff

Wide.PPC.xcoff.MrC		{MondoBuild} Wide.xcoff

Wide.68K.lib			{MondoBuild} Wide.lib

Wide.68K.lib.SC			{MondoBuild} Wide.lib

# real targets
Wide.xcoff			{MondoBuild} {ObjectsPPC}
	PPCLink 
		-o {WidePPC} {SymPPC} 
		{ObjectsPPC} 
		-xm library 
		-t 'XCOF' 
		-c 'MPS '


Wide.lib			{MondoBuild} {Objects68K}
	Lib 
		-o {Wide68K} {Sym68K} 
		{Objects68K}


"{ObjDirPPC}Wide.c.x"		{MondoBuild} {Sources}Wide.c 
							{Includes}Wide.h
	If "{MPWVersion}" !~ /3.4/
		# old PPCC compiler requires Apple Extensions option to be on
		{PPCC} {Sources}Wide.c -o {Targ} {PPCCOptions} -appleext on
	Else
		{PPCC} {Sources}Wide.c -o {Targ} {PPCCOptions}
	End


"{ObjDir68K}Wide.a.o"		{MondoBuild} {Sources}Wide.a
	{Asm} {Sources}Wide.a -o {Targ} {AOptions}

"{ObjDir68K}Wide.c.o"		{MondoBuild} {Sources}Wide.c 
							{Includes}Wide.h
	{C} {Sources}Wide.c -o {Targ} {COptions}

