# NeXT Makefile for the the Eclectus difference utility
# Copyright (C) 1992 Eclectus (D. John Anderson, Alan B. Harper).

# This file is part of the Eclectus integration utilities.

# Eclectus integration utilities are free software; you can redistribute
# it and/or modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 1, or
# (at your option) any later version.

# Eclectus integration utilities is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with the Eclectus integration utilities; see the file COPYING.
# If not, write to the Free Software Foundation, 675 Mass Ave, Cambridge,
# MA 02139, USA.

# We can't use -pedantic because the braindamaged NeXT includes aren't ANSI compatible.

DEBUG_C_OPTIONS = -g -I$(DERIVED_DIR) -I$(OBERISH_DIR) -DDF_DEBUG -Wall -ansi\
	-pedantic -DDF_MACHINE_NEXT -DDF_COMPILER_GNU -D_NEXT_SOURCE

C_OPTIONS = -O -I$(DERIVED_DIR) -fomit-frame-pointer -ansi -DDF_MACHINE_NEXT -DDF_COMPILER_GNU\
 -D_NEXT_SOURCE

#VPATH specifies where to look for dates on object files
VPATH = $(DERIVED_DIR):

H_FILES = \
	diff.h

DIFFERENCE_C_FILES =\
	Difference.c \
	analyze.c \
	io.c \
	util.c

LOADLIBS = -lsys_s

BIN_DIR = ../../ECTools
DERIVED_DIR = DerivedDifference.i
OBERISH_DIR = ../Oberish

DIFFERENCE_OBJS = $(DIFFERENCE_C_FILES:.c=.o) $(DEBUG_OBJS)

All: Difference

Difference: $(DERIVED_DIR) tags $(DIFFERENCE_OBJS)
	$(CC) $(C_OPTIONS) -o $(DERIVED_DIR)/$@ $(DIFFERENCE_OBJS) $(LOADLIBS)

clean:
	-/bin/rm -rf $(DERIVED_DIR)

debug:
	$(MAKE) -f NextDifference.make "C_OPTIONS = $(DEBUG_C_OPTIONS)" "DEBUG_OBJS = DebugMalloc.o" All

install: $(BIN_DIR)
	install -m 755 $(DERIVED_DIR)/Difference $(BIN_DIR)/Difference

$(BIN_DIR):
	mkdirs -m 755 $@

.c.o:
	$(CC) $(C_OPTIONS) -c $*.c -o $(DERIVED_DIR)/$*.o

tags:
	ctags -o $(DERIVED_DIR)/tags $(DIFFERENCE_C_FILES) $(H_FILES)

DebugMalloc.o: ../Oberish/DebugMalloc.c
	$(CC) $(C_OPTIONS) -c ../Oberish/DebugMalloc.c -o $(DERIVED_DIR)/DebugMalloc.o

$(DERIVED_DIR):
	mkdirs -m 755 $@



