/****************************************************************************
 * 
 * DocumentHelpers.h 
 * 
 ****************************************************************************/

#ifndef __DOCUMENTHELPERS__
#define __DOCUMENTHELPERS__

#include "Structs.h"

// --- PUBLIC PROTOTYPES --------------------------------------------------------------------------

DocumentReference		GetDocumentByWindow					(DocumentList list, WindowPtr window);
DocumentReference		GetDocumentByName						(ConstStr63Param nameToFind);
DocumentReference		GetDocumentByIndex					(long index);
OSErr						GetDocumentByDocumentNumber		(long internalNumber, DocumentReference *document);

DocumentReference		GetFrontDocument						(DocumentList list);
DocumentReference		GetNextFrontDocument					(DocumentList list, DocumentReference document);

void						InvalDocument							(DocumentReference document);

//
// --- Acessor Synonyms
//
DocumentReference		GetNextDocument						(DocumentReference document);
DocumentReference		GetPreviousDocument					(DocumentReference document);
Boolean					DocumentIsModified					(DocumentReference document);

//
// --- Manipulators Synonyms
//
void						HideDocument							(DocumentReference document);
void						ShowDocument							(DocumentReference document);
void						MarkDocumentAsChanged				(DocumentReference document);

#endif
