/****************************************************************************
 * 
 * AERCoreSuite.h
 * 
 * Functions related to OLS Support for the core suite
 *
 ****************************************************************************/

#ifndef __AERCORESUITE__
#define __AERCORESUITE__
 
#include <AEObjects.h>
#include <AERegistry.h>
#include <AEPackObject.h>

// ----------------------------------------------------------------------------
// This is the token record used for all tokens in the CORE Suite
// This uses the "kitchen sink" token metaphor: a single token is used to represent
// all objects, and some fields are only appropriate for some objects.

typedef struct CoreTokenRecord
{
	DescType				dispatchClass;		// the class that will dispatch this class
	DescType				objectClass;		// the actual class of the tokenized object
	DescType				propertyCode;		// property code, or typeNull if not a property token
	long					documentNumber;
	long					elementNumber;
	WindowPtr			window;				// only used for window objects
} CoreTokenRecord, *CoreTokenPtr, **CoreTokenHandle;

// ---------------------------------------------------------------------------

Boolean			InstallCoreSuiteHandlers			(void);


void				InitCoreTokenRecord					(CoreTokenRecord *token);

pascal OSErr 
PropertyTokenFromAEListOfTokens(	DescType		desiredClass,
					 				const AEDesc*		containerToken,
					 						DescType		containerClass,
					 						DescType		keyForm,
				    				const AEDesc*		keyData,
					 						AEDesc*		resultToken,
					 						long 			refCon);

// ---------------------------------------------------------------------------

#endif
